/* 
LM75 I2C thermometer
-----------------
*/
#include <stdio.h>
#include <stdlib.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <unistd.h>
#include <linux/i2c-dev.h>
#define I2C_SLAVE 0x0703 /* Change slave address */

int i2c;
char filename[20];
unsigned long address;
int rc;
unsigned char data[2];
int byte1;
int byte2;
int temperature;
double realtemp;
int main(int argc, char ** argv)
{
if (argc != 2) { /* error if we are not getting just 1 input after the program name */
fprintf(stderr, "usage: %s <address> \n",argv[0]);
exit(1);
}

/* address is the first number after the program name */
address = atoi(argv[1]);

i2c = open("/dev/i2c-0",O_RDWR); /* open the device dev/i2c-0 */
rc=ioctl(i2c,I2C_SLAVE,address); /* set the i2c chip address */

read(i2c,data,2);

byte1 = data[0];
byte2 = data[1];

temperature = byte1*256+byte2;
temperature >>=7;
if (temperature>512)
temperature &= -1;

realtemp = (double)temperature / 2;
printf("%.1f", realtemp);

i2c = close(i2c);
return(0);
}